Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography Library 1.85
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.bouncycastle.crypto.io
Class CipherInputStream

    java.lang.Object
      java.io.InputStream
          java.io.FilterInputStream
              org.bouncycastle.crypto.io.CipherInputStream

public class CipherInputStream
extends java.io.FilterInputStream

A CipherInputStream is composed of an InputStream and a cipher so that read() methods return data that are read in from the underlying InputStream but have been additionally processed by the Cipher. The cipher must be fully initialized before being used by a CipherInputStream.

For example, if the Cipher is initialized for decryption, the CipherInputStream will attempt to read in data and decrypt them, before returning the decrypted data.

Field Summary

Fields inherited from class java.io.FilterInputStream
`in`

Constructor Summary
`CipherInputStream(java.io.InputStream is, AEADBlockCipher cipher)` Constructs a CipherInputStream from an InputStream and an AEADBlockCipher.
`CipherInputStream(java.io.InputStream is, AEADBlockCipher cipher, int bufSize)` Constructs a CipherInputStream from an InputStream, an AEADBlockCipher, and a specified internal buffer size.
`CipherInputStream(java.io.InputStream is, BufferedBlockCipher cipher)` Constructs a CipherInputStream from an InputStream and a BufferedBlockCipher.
`CipherInputStream(java.io.InputStream is, BufferedBlockCipher cipher, int bufSize)` Constructs a CipherInputStream from an InputStream, a BufferedBlockCipher, and a specified internal buffer size.
`CipherInputStream(java.io.InputStream is, StreamCipher cipher)` Constructs a CipherInputStream from an InputStream and a StreamCipher.
`CipherInputStream(java.io.InputStream is, StreamCipher cipher, int bufSize)` Constructs a CipherInputStream from an InputStream, a StreamCipher, and a specified internal buffer size.

Method Summary
`int` | `available()`
`void` | `close()` Closes the underlying input stream and finalises the processing of the data by the cipher.
`void` | `mark(int readlimit)` Mark the current position.
`boolean` | `markSupported()` Return true if mark(readlimit) is supported.
`int` | `read()` Reads data from the underlying stream and processes it with the cipher until the cipher outputs data, and returns the next available byte.
`int` | `read(byte[] b)` Reads data from the underlying stream and processes it with the cipher until the cipher outputs data, and then returns up to b.length bytes in the provided array.
`int` | `read(byte[] b, int off, int len)` Reads data from the underlying stream and processes it with the cipher until the cipher outputs data, and then returns up to len bytes in the provided array.
`void` | `reset()` Reset to the last marked position, if supported.
`long` | `skip(long n)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CipherInputStream

    public CipherInputStream(java.io.InputStream is,
                             BufferedBlockCipher cipher)

  Constructs a CipherInputStream from an InputStream and a BufferedBlockCipher.

### CipherInputStream

    public CipherInputStream(java.io.InputStream is,
                             StreamCipher cipher)

  Constructs a CipherInputStream from an InputStream and a StreamCipher.

### CipherInputStream

    public CipherInputStream(java.io.InputStream is,
                             AEADBlockCipher cipher)

  Constructs a CipherInputStream from an InputStream and an AEADBlockCipher.

### CipherInputStream

    public CipherInputStream(java.io.InputStream is,
                             BufferedBlockCipher cipher,
                             int bufSize)

  Constructs a CipherInputStream from an InputStream, a BufferedBlockCipher, and a specified internal buffer size.

### CipherInputStream

    public CipherInputStream(java.io.InputStream is,
                             StreamCipher cipher,
                             int bufSize)

  Constructs a CipherInputStream from an InputStream, a StreamCipher, and a specified internal buffer size.

### CipherInputStream

    public CipherInputStream(java.io.InputStream is,
                             AEADBlockCipher cipher,
                             int bufSize)

  Constructs a CipherInputStream from an InputStream, an AEADBlockCipher, and a specified internal buffer size.

Method Detail

### read

    public int read()
             throws java.io.IOException

  Reads data from the underlying stream and processes it with the cipher until the cipher outputs data, and returns the next available byte.

  If the underlying stream is exhausted by this call, the cipher will be finalised.

  Throws:
    `java.io.IOException` - if there was an error closing the input stream.
    `InvalidCipherTextIOException` - if the data read from the stream was invalid ciphertext (e.g. the cipher is an AEAD cipher and the ciphertext tag check fails).

### read

    public int read(byte[] b)
             throws java.io.IOException

  Reads data from the underlying stream and processes it with the cipher until the cipher outputs data, and then returns up to b.length bytes in the provided array.

  If the underlying stream is exhausted by this call, the cipher will be finalised.

  Parameters:
    `b` - the buffer into which the data is read.
  Returns:
    the total number of bytes read into the buffer, or -1 if there is no more data because the end of the stream has been reached.
  Throws:
    `java.io.IOException` - if there was an error closing the input stream.
    `InvalidCipherTextIOException` - if the data read from the stream was invalid ciphertext (e.g. the cipher is an AEAD cipher and the ciphertext tag check fails).

### read

    public int read(byte[] b,
                    int off,
                    int len)
             throws java.io.IOException

  Reads data from the underlying stream and processes it with the cipher until the cipher outputs data, and then returns up to len bytes in the provided array.

  If the underlying stream is exhausted by this call, the cipher will be finalised.

  Parameters:
    `b` - the buffer into which the data is read.
    `off` - the start offset in the destination array b
    `len` - the maximum number of bytes read.
  Returns:
    the total number of bytes read into the buffer, or -1 if there is no more data because the end of the stream has been reached.
  Throws:
    `java.io.IOException` - if there was an error closing the input stream.
    `InvalidCipherTextIOException` - if the data read from the stream was invalid ciphertext (e.g. the cipher is an AEAD cipher and the ciphertext tag check fails).

### skip

    public long skip(long n)
              throws java.io.IOException

  Throws:
    `java.io.IOException`

### available

    public int available()
                  throws java.io.IOException

  Throws:
    `java.io.IOException`

### close

    public void close()
               throws java.io.IOException

  Closes the underlying input stream and finalises the processing of the data by the cipher.

  Throws:
    `java.io.IOException` - if there was an error closing the input stream.
    `InvalidCipherTextIOException` - if the data read from the stream was invalid ciphertext (e.g. the cipher is an AEAD cipher and the ciphertext tag check fails).

### mark

    public void mark(int readlimit)

  Mark the current position.

  This method only works if markSupported() returns true - which means the underlying stream supports marking, and the cipher passed in to this stream's constructor is a SkippingCipher (so capable of being reset to an arbitrary point easily).

  Parameters:
    `readlimit` - the maximum read ahead required before a reset() may be called.

### reset

    public void reset()
               throws java.io.IOException

  Reset to the last marked position, if supported.

  Throws:
    `java.io.IOException` - if marking not supported by the cipher used, or the underlying stream.

### markSupported

    public boolean markSupported()

  Return true if mark(readlimit) is supported. This will be true if the underlying stream supports marking and the cipher used is a SkippingCipher,

  Returns:
    true if mark(readlimit) supported, false otherwise.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography Library 1.85
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD